exercise_04_25: exercise_04_25.o | .gitignore
	g++ $^ -o $@ 

exercise_04_25.ii: exercise_04_25.cpp
	g++ -E $^ -o $@

exercise_04_25.s: exercise_04_25.ii
	g++ -S $^ -o $@

exercise_04_25.o: exercise_04_25.s
	g++ -c $^ -o $@

.gitignore:
	echo "exercise_04_25" > $@

clean:
	rm -rf *.ii *.s *.o *.out exercise_04_25 .gitignore debug

test: exercise_04_25 
	./exercise_04_25 < test.in > test.out
	diff test.out test.expected > /dev/null 2>&1 && echo PASSED || echo FAILED

.PRECIOUS: exercise_04_25.ii exercise_04_25.s
.SECONDARY: exercise_04_25.ii exercise_04_25.s

dbg: debug/exercise_04_25 

debug/exercise_04_25: debug/exercise_04_25.o | .gitignore
	g++ -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_25.o: debug/exercise_04_25.s
	g++ -c -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_25.s: debug/exercise_04_25.ii
	g++ -S -Wall -Wextra -Werror -g3 $^ -o $@

debug/exercise_04_25.ii: exercise_04_25.cpp | debug
	g++ -E -Wall -Wextra -Werror -g3 $^ -o $@

debug:
	mkdir -p debug

